//--------------------------------------------------------------
// File     : axel.c
// Datum    : 07.09.2014
// Version  : 1.0
// Autor    : AJ
// CPU      : STM32F4
// IDE      : CooCox CoIDE 1.7.0
//
//--------------------------------------------------------------
// Funktion : 
// Funktionen von Axel
// 
//--------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "stm32f4xx.h"
#include "stm32f4xx_gpio.h"
#include "stm32f4xx_rcc.h"
#include "stm32f4xx_tim.h"
#include "misc.h"

#include "main.h"
#include "stm32_ub_lcd_ssd1289.h"
#include "stm32_ub_font.h"
#include "stm32_ub_touch_ads7843.h"



//*****  Function Prototype **************************************************


void UB_Graphic_DrawPixel (int16_t xpos, int16_t ypos, uint16_t color);
void UB_Graphic_DrawLine(int16_t x1, int16_t y1, int16_t x2, int16_t y2, uint16_t color);
void P_LCD1289_WriteReg(uint8_t reg_adr, uint16_t reg_value);

// **********************************************************************************

char buf[20];

// ********************************************************************************** 
void tohex4(unsigned long h1)
{
  unsigned int h;
    h=h1/1000; buf[0]=(h+0x30); h1-=(h*1000);
    h=h1/100;  buf[1]=(h+0x30); h1-=(h*100);
    h=h1/10;   buf[2]=(h+0x30); h1-=(h*10);
               buf[3]=(h1+0x30);
}
// **********************************************************************************
 
// ********************************************************************************** 
void tohex3(unsigned long h1)
{
  unsigned int h;
    h=h1/100;  buf[0]=(h+0x30); h1-=(h*100);
    h=h1/10;   buf[1]=(h+0x30); h1-=(h*10);
               buf[2]=(h1+0x30);
}
// ********************************************************************************** 

// ********************************************************************************** 
void tohex2m(unsigned long h1)
{
  unsigned int h;
               buf[0]=0x2d; // "-"
    h=h1/10;   buf[1]=(h+0x30); h1-=(h*10);
               buf[2]=(h1+0x30);
}
// ********************************************************************************** 

// ********************************************************************************** 
void tohex2(unsigned long h1)
{
  unsigned int h;
               buf[2]=0x00; // ""
    h=h1/10;   buf[0]=(h+0x30); h1-=(h*10);
               buf[1]=(h1+0x30);
}
// ********************************************************************************** 


// **********************************************************************************
void tohex5(unsigned long h1)
{
  unsigned long h;

  	h=h1/10000; h1-=(h*10000); if (h==0) buf[0]=(0x20) ; else buf[0]=(h+0x30);
    h=h1/1000;  h1-=(h*1000); if (h==0 && buf[0]==(0x20)) buf[1]=(0x20) ; else buf[1]=(h+0x30);
    h=h1/100;   h1-=(h*100); if (h==0 && buf[1]==(0x20)) buf[2]=(0x20) ; else buf[2]=(h+0x30);
    h=h1/10;    h1-=(h*10); if (h==0 && buf[2]==(0x20)) buf[3]=(0x20) ; else buf[3]=(h+0x30);
                buf[4]=(h1+0x30);
}
// **********************************************************************************



// **********************************************************************************
//   Einlesen einer 50x50 Pixel groen Funktionstaste
//   Tastflche wird wei umrandet und bei Bettigung rot dargestellt
//   der Aufsetzpunkt ist unten links
// **********************************************************************************
unsigned int funkt50_50 (uint16_t x, uint16_t y, uint16_t fktouch_x, uint16_t fktouch_y)
{

unsigned char tast;


if((x >= fktouch_x) & (x <= (fktouch_x+50)) &  (y >= fktouch_y) & (y <= (fktouch_y+50)) )
{tast=1; 	// bettigt
UB_Graphic_DrawLine(fktouch_x,fktouch_y,fktouch_x,(fktouch_y+50),RGB_COL_RED);
UB_Graphic_DrawLine(fktouch_x,fktouch_y,(fktouch_x+50),fktouch_y,RGB_COL_RED);
UB_Graphic_DrawLine(fktouch_x,(fktouch_y+50),(fktouch_x+50),(fktouch_y+50),RGB_COL_RED);
UB_Graphic_DrawLine((fktouch_x+50),(fktouch_y),(fktouch_x+50),(fktouch_y+50),RGB_COL_RED);
}

else 		// unbettigt
{tast=0; 
UB_Graphic_DrawLine(fktouch_x,fktouch_y,fktouch_x,(fktouch_y+50),RGB_COL_WHITE);
UB_Graphic_DrawLine(fktouch_x,fktouch_y,(fktouch_x+50),fktouch_y,RGB_COL_WHITE);
UB_Graphic_DrawLine(fktouch_x,(fktouch_y+50),(fktouch_x+50),(fktouch_y+50),RGB_COL_WHITE);
UB_Graphic_DrawLine((fktouch_x+50),(fktouch_y),(fktouch_x+50),(fktouch_y+50),RGB_COL_WHITE);

}

return tast;

}

// **********************************************************************************

// **********************************************************************************
//   Einlesen einer 75x30 Pixel groen Funktionstaste
//   Tastflche wird grau umrandet und bei Bettigung rot dargestellt
//   der Aufsetzpunkt ist unten links
// 
//   x,y = aktuelle Touch Koordinaten
//   fktouch_x,  fktouch_y = Aufsetzpunkt 



// **********************************************************************************
unsigned int funkt75_30 (uint16_t x, uint16_t y, uint16_t fktouch_x, uint16_t fktouch_y)
{

unsigned char tast;


if((x >= fktouch_x) & (x <= (fktouch_x+75)) &  (y >= fktouch_y) & (y <= (fktouch_y+30)) )
{tast=1; 	// bettigt
UB_Graphic_DrawLine(fktouch_x,fktouch_y,fktouch_x,(fktouch_y+30),RGB_COL_RED);
UB_Graphic_DrawLine(fktouch_x,fktouch_y,(fktouch_x+75),fktouch_y,RGB_COL_RED);
UB_Graphic_DrawLine(fktouch_x,(fktouch_y+30),(fktouch_x+75),(fktouch_y+30),RGB_COL_RED);
UB_Graphic_DrawLine((fktouch_x+75),(fktouch_y),(fktouch_x+75),(fktouch_y+30),RGB_COL_RED);
}

else 		// unbettigt
{tast=0; 
UB_Graphic_DrawLine(fktouch_x,fktouch_y,fktouch_x,(fktouch_y+30),21130);
UB_Graphic_DrawLine(fktouch_x,fktouch_y,(fktouch_x+75),fktouch_y,21130);
UB_Graphic_DrawLine(fktouch_x,(fktouch_y+30),(fktouch_x+75),(fktouch_y+30),21130);
UB_Graphic_DrawLine((fktouch_x+75),(fktouch_y),(fktouch_x+75),(fktouch_y+30),21130);

}

return tast;

}

// **********************************************************************************

//--------------------------------------------------------------
// setzt den Cursor auf x,y Position
// und zeichnet einen Balken
//--------------------------------------------------------------
void LCD_Draw_Bar_graph(uint16_t xpos, uint16_t ypos, uint16_t ymax, uint16_t wert)
{
	uint16_t n;
	uint16_t ny;
	// Cursor setzen
  P_LCD1289_WriteReg(LCD_SSD1289_REG_4E, ypos);
  P_LCD1289_WriteReg(LCD_SSD1289_REG_4F, xpos);
  LCD_REG=LCD_SSD1289_REG_22;   // adresse anlegen


  for(ny=ypos;ny<(ymax);ny++) {
	  P_LCD1289_WriteReg(LCD_SSD1289_REG_4F, xpos);
	  P_LCD1289_WriteReg(LCD_SSD1289_REG_4E, ny);
	  LCD_REG=LCD_SSD1289_REG_22;

  for(n=xpos;n<(xpos+5);n++) {
	if(ny<(wert+ypos))  LCD_RAM=RGB_COL_RED; else LCD_RAM=RGB_COL_WHITE;


  }


  }



}

// **********************************************************************************

//--------------------------------------------------------------
// setzt den Cursor auf x,y Position
// und zeichnet eine waagerechte Linie
//--------------------------------------------------------------
void LCD_line(uint16_t xpos, uint16_t ypos , uint16_t coll )
{
	uint16_t n;
	// Cursor setzen
  P_LCD1289_WriteReg(LCD_SSD1289_REG_4E, ypos);
  P_LCD1289_WriteReg(LCD_SSD1289_REG_4F, xpos);
  LCD_REG=LCD_SSD1289_REG_22;   // adresse anlegen


  for(n=xpos;n<(xpos+150);n++) {
	LCD_RAM=coll;
  }


  }





